/******
 *
 *	Edit Area v0.5
 * 	Developped by Christophe Dolivet
 *	Released under LGPL license
 *
******/

	function EditArea(){
		this.error= false;	// to know if load is interrrupt
		//this.loadedFiles = new Array();
		//this.baseURL="";
		//this.file_name="edit_area.js";
		//this.suffix="";
		//this.cssToLoad= new Array("edit_area.css");
		this.inlinePopup= new Array({popup_id: "area_search_replace", icon_id: "search_icon"},
									{popup_id: "edit_area_help", icon_id: "help_icon"});
	
		this.line_number=0;
		
		this.nav=parent.editAreaLoader.nav; 	// navigator identification
		//this.previous_content= new Array();
		//this.previous_text="";
		//this.last_highlight_line_selected= -1;
		//this.tab_text_operator= new Array("=","+","-","/","*",";","->");
		/*this.is_updating=false;
		this.is_waiting_for_update=false;
		this.last_line_selected= -1;		
		this.last_selection_range= -1;*/
		this.last_selection=new Array();		
		this.last_text_to_highlight="";
		this.last_hightlighted_text= "";
		
		this.textareaFocused= false;
		this.previous= new Array();
		this.next= new Array();
		//this.loaded= false;
		this.assocBracket=new Array();
		this.revertAssocBracket= new Array();		
		// bracket selection init 
		this.assocBracket["("]=")";
		this.assocBracket["{"]="}";
		this.assocBracket["["]="]";		
		for(var index in this.assocBracket){
			this.revertAssocBracket[this.assocBracket[index]]=index;
		}
		/*this.textarea="";	
		
		this.state="declare";
		this.code = new Array(); // store highlight syntax for languagues*/
		// font datas
		this.lineHeight= 16;
		this.charWidth=8;
		/*this.default_font_family= "monospace";
		this.default_font_size= 10;*/
		this.tab_nb_char= 8;	//nb of white spaces corresponding to a tabulation
		if(this.nav['isOpera'])
			this.tab_nb_char= 6;
		this.is_tabbing= false;
		
		
		this.isResizing=false;	// resize var
		/*
		this.resize_start_mouse_x=0;
		this.resize_start_mouse_y=0;
		this.resize_start_width=0;
		this.resize_start_height=0;
		this.resize_new_width=0;
		this.resize_new_height=0;
		this.resize_start_inner_height=0;	
		this.min_width= 400;
		this.min_height= 50;
		this.resize_mouse_x=0;
		this.resize_mouse_y=0;
		// available options
		this.do_highlight=false;
		this.settings["debug"]=false; 
		this.id="";
		this.font_family= "monospace";
		this.font_size= 10;
		this.smooth_selection= true;
		this.max_undo= 15;
		this.save_callback="";
		this.load_callback="";
		this.toolbar= "new_document, |, search, go_to_line, |, undo, redo, |, select_font, change_smooth_selection, highlight, reset_highlight, |, help";
		this.allow_resize= "both"; // "no", "x", "y", "both"
		this.allow_toogle=true;
		this.language="en";
		this.do_html_tags= true;
		this.code_lang="php";
		this.lang_style= new Array();*/
		/*
		//load needed files
		if(this.file_name!="edit_area_gzip.php"){	// don't load files if they were loaded in php		
			for(var script in this.scriptsToLoad){
				this.loadScript(this.baseURL + this.scriptsToLoad[script]+ this.suffix +".js");
			}
		}
		
		for(var css in this.cssToLoad){
			this.loadCSS(this.baseURL + this.cssToLoad[css]);
		}*/
	};
	
	
	//called by the toogle_on
	EditArea.prototype.update_size= function(){
		toolbar_height= document.body.offsetHeight - this.get_all_toolbar_height() - 4;
		document.getElementById("result").style.height= toolbar_height +"px";

		//width=document.getElementById("editor").offsetWidth - 2;
		//width=parent.document.getElementById("frame_"+this.id).offsetWidth - 2;
		width=document.body.offsetWidth -2;
		document.getElementById("result").style.width= width+"px";
		//alert("result h: "+toolbar_height+" w: "+width);		
	};

	EditArea.prototype.init= function(){
		//alert("ini"+document.body.offsetWidth );
		/*document.open();
		document.write("bouh");
		document.close();*/
		this.id= area_id;
		this.settings= editAreas[this.id]["settings"];
		this.textarea= document.getElementById("textarea");
		
		// init datas
		this.textarea.value=editAreas[this.id]["textarea"].value;
		if(this.settings["debug"])
			this.debug=parent.document.getElementById("edit_area_debug_"+this.id);
		
		// init size		
		//this.update_size();
		
		if(document.getElementById("redo_icon") != null)
			this.switchClassSticky(document.getElementById("redo_icon"), 'editAreaButtonDisabled', true);
		
		
		
		// insert css rules for highlight mode		
		if(typeof(parent.editAreaLoader.syntax[this.settings["syntax"]])!="undefined"){
			var styles=parent.editAreaLoader.syntax[this.settings["syntax"]]["styles"];
					
			if(styles.length>0){
				if(document.createStyleSheet){ 
					document.createStyleSheet("javascript:'"+styles+"'");
				}else{
					newSS= document.createElement('link'); 
					newSS.rel= 'stylesheet'; 
					newSS.href= 'data:text/css,'+escape(styles); 
					document.getElementsByTagName("head")[0].appendChild(newSS);
				}
			}
		}
		// init key events
		if(this.nav['isOpera'])
			document.getElementById("editor").onkeypress= keyDown;
		else
			document.getElementById("editor").onkeydown= keyDown;
	/*	if(this.nav['isIE'] || this.nav['isFirefox'])
			this.textarea.onkeydown= keyDown;
		else if
			this.textarea.onkeypress= keyDown;*/
		for(var i in this.inlinePopup){
			if(this.nav['isIE'] || this.nav['isFirefox'])
				document.getElementById(this.inlinePopup[i]["popup_id"]).onkeydown= keyDown;
			else
				document.getElementById(this.inlinePopup[i]["popup_id"]).onkeypress= keyDown;
		}
		
		if(this.settings["allow_resize"]!="no")
		{
			document.getElementById("resize_area").style.visibility="visible";
			document.getElementById("resize_area").onmouseup= editArea.start_resize;
		}
		
		parent.editAreaLoader.toogle(this.id, "on");
		//this.textarea.focus();
		// line selection init
		this.change_smooth_selection_mode(editArea.smooth_selection);
		// highlight
		this.change_highlight(this.settings["start_highlight"]);
		
		// get font size datas		
		this.set_font(editArea.settings["font_family"], editArea.settings["font_size"]);
		
		// set unselectable text
		children= parent.getChildren(document.body, "", "selec", "none", "all", -1);
		for(var i in children){
			if(this.nav['isIE'])
				children[i].unselectable = true; // IE
			else
				children[i].onmousedown= function(){return false};
			/*
			children[i].style.MozUserSelect = "none"; // Moz
			children[i].style.KhtmlUserSelect = "none";  // Konqueror/Safari*/
			
		}
		
		if(this.nav['isOpera']){
			document.getElementById("editor").style.position= "absolute";
			document.getElementById("selection_field").style.marginTop= "-1pt";			
			document.getElementById("selection_field").style.paddingTop= "1pt";
			document.getElementById("cursor_pos").style.marginTop= "-1pt";
			document.getElementById("end_bracket").style.marginTop= "-1pt";
			document.getElementById("content_highlight").style.marginTop= "-1pt";
			/*document.getElementById("end_bracket").style.marginTop="1px";*/
		}
		if(this.nav['isIE']>=7){
			/*document.getElementById("editor").style.marginTop="-2px";
			document.getElementById("editor").style.marginLeft="-2px";*/
		}
		
		setTimeout("editArea.manage_size();", 10);		
		//start checkup routine
		this.check_undo();
		this.check_line_selection(true);
		this.scroll_to_view();
		
		/*date= new Date();
		alert(date.getTime()- parent.editAreaLoader.start_time);*/
	};
	
	EditArea.prototype.manage_size= function(){
		if(editAreas[this.id]["displayed"]==true)
		{
			var resized= false;
			area_width= this.textarea.scrollWidth;
			area_height= this.textarea.scrollHeight;
			if(this.nav['isOpera']){
				area_height= this.last_selection['nb_line']*this.lineHeight;
				//area_width-=45;
				area_width=10000; /* TODO: find a better way to fix the width problem */
				//elem= document.getElementById("container");
				//elem= this.textarea;
				//window.status="area over: area_width "+area_width+" scroll: "+elem.scrollWidth+" offset: "+elem.offsetWidth +" client: "+ elem.clientWidth+" style: "+elem.style.width;
				//window.status+=" area_height "+area_height+" scroll: "+elem.scrollHeight+" offset: "+elem.offsetHeight +" client: "+ elem.clientHeight;				
			}
			
			if(this.nav['isIE']==7)
				area_width-=45;
	
			if(this.nav['isGecko'] && this.smooth_selection && this.last_selection["nb_line"])
				area_height= this.last_selection["nb_line"]*this.lineHeight;
				
			if(this.last_selection["nb_line"] >= this.line_number)
			{
				var div_line_number="";
				for(i=this.line_number+1; i<this.last_selection["nb_line"]+100; i++)
				{
					div_line_number+=i+"<br />";
					this.line_number++;
				}
				var span= document.createElement("span");
				if(this.nav['isIE'])
					span.unselectable=true;
				span.innerHTML=div_line_number;					
				document.getElementById("line_number").appendChild(span);				
			}
			//alert(area_height);
			if(this.textarea.previous_scrollWidth!=area_width)
			{
				if(this.nav['isOpera']){
					/*if(this.textarea.style.width.replace("px","")-0+50 < area_width)
						area_width+=50;*/
				}else{
					if(this.textarea.style.width.replace("px","") < area_width){
						area_width+=50;
					}
				}
				
				if(this.nav['isGecko'] || this.nav['isOpera'])
					document.getElementById("container").style.width= (area_width+45)+"px";
				else
					document.getElementById("container").style.width= area_width+"px";
				document.getElementById("textarea").style.width= area_width+"px";
				document.getElementById("content_highlight").style.width= area_width+"px";	
				this.textarea.previous_scrollWidth=area_width;
				resized=true;
			}		
			if(this.textarea.previous_scrollHeight!=area_height)	
			{
				/*container_height=area_height;
				if(document.getElementById("container").style.height.replace("px", "")<=area_height)
					container_height+=100;*/
				document.getElementById("container").style.height= (area_height+2)+"px";
				document.getElementById("textarea").style.height= area_height+"px";
				document.getElementById("content_highlight").style.height= area_height+"px";	
				this.textarea.previous_scrollHeight=area_height;
				//alert(area_height);
				resized=true;
			}
			this.textarea.scrollTop="0px";
			this.textarea.scrollLeft="0px";
			if(resized==true){
				this.scroll_to_view();
			}
		}
		setTimeout("editArea.manage_size();", 100);
	};
	
	EditArea.prototype.addEvent = function(obj, name, handler) {
		if (this.nav['isIE']) {
			obj.attachEvent("on" + name, handler);
		} else{
			obj.addEventListener(name, handler, false);
		}
	};
	
	EditArea.prototype.execCommand= function(cmd){
		switch(cmd){
			case "save":
				if(this.settings["save_callback"].length>0)
					eval("parent."+this.settings["save_callback"]+"(editArea.textarea.value);");
				break;
			case "load":
				if(this.settings["load_callback"].length>0)
					eval("parent."+this.settings["load_callback"]+"(editArea.textarea);");
				break;			
			case "re_sync":
				if(!this.do_highlight)
					break;
			default:
				eval("editArea."+cmd+"();");	
		}
	};
	
	EditArea.prototype.get_translation= function(word){
		return parent.editAreaLoader.get_word_translation(word, this.settings["language"]);
	};

	var editArea = new EditArea();	
	editArea.addEvent(window, "load", init);
	
	function init(){		
		setTimeout("editArea.init();  ", 10);
	};
	
